<template>
  <div id="filterCard">
    <div class="filter-topic">
      <label class="filter-topic-font">Filter</label>
      <label class="clear-all" @click="clearFilter">clear all</label>
    </div>
    <v-card class="mx-auto custom-card" :loading="loadingBeforeGetCatalog" width="270">
      <div class="category-group">
        <div
          class="category-topic"
          :class="{'expand-active': categoryActive}"
          @click="categoryActive = !categoryActive"
        >
          ประเภทสินค้า
          <v-icon color="black" v-if="!categoryActive">mdi-chevron-down</v-icon>
          <v-icon color="black" v-else>mdi-chevron-right</v-icon>
        </div>
        <template v-if="categoryActive">
          <div v-for="category in categories" :key="category.id">
            <div class="category-option-name">
              <div
                @click="categoryExpand(category.id)"
                :class="{'expand-active': categoryExpandList.includes(category.id)}"
              >{{category.name}}</div>
              <div class="sub-category" v-if="categoryExpandList.includes(category.id)">
                <div
                  class="sub-category-all"
                  @click="selectCategoryAllFunc(category.childs)"
                  :class="{'active-click-all': activeClickAll(category.childs)}"
                >{{`${category.name}ทั้งหมด`}}</div>
                <div
                  id="categoryOption"
                  v-for="subCategory in category.childs"
                  :key="subCategory.id"
                >
                  <v-checkbox
                    color="#1653ba"
                    v-model="selectCategory"
                    :label="subCategory.name"
                    :value="subCategory"
                  />
                </div>
              </div>
            </div>
          </div>
        </template>
      </div>
      <div class="brands-box-group">
        <div
          class="brands-topic"
          :class="{'expand-active': brandActive}"
          @click="brandActive = !brandActive"
        >
          แบรนด์
          <v-icon color="black" v-if="!brandActive">mdi-chevron-down</v-icon>
          <v-icon color="black" v-else>mdi-chevron-right</v-icon>
        </div>
        <template v-if="brandActive">
          <div id="brandsOption" v-for="brand in brands" :key="brand.id">
            <v-checkbox color="#1653ba" v-model="selectBrands" :label="brand.name" :value="brand" />
          </div>
        </template>
      </div>
    </v-card>
  </div>
</template>

<script>
import { mapActions } from "vuex";

export default {
  name: "filterCard",
  data() {
    return {
      categories: [],
      categoryActive: true,
      brands: [],
      brandActive: true,
      loadingBeforeGetCatalog: false,
      categoryExpandList: []
    };
  },
  computed: {
    selectCategoryAll: {
      get() {
        return this.$store.state.catalog.category;
      },
      set(value) {
        let countValue = 0;
        value.map(data => {
          const alreadyValue = this.$store.state.catalog.category.findIndex(
            e => e.id === data.id
          );
          if (alreadyValue > -1) {
            countValue += 1;
            this.setCategoryIdList(alreadyValue);
          }
        });
        if (countValue !== value.length) {
          const oldData = this.$store.state.catalog.category;
          const sumValue = value.concat(oldData);
          this.setCategory(sumValue);
        }
      }
    },
    selectCategory: {
      get() {
        return this.$store.state.catalog.category;
      },
      set(value) {
        this.setCategory(value);
      }
    },
    selectBrands: {
      get() {
        return this.$store.state.catalog.brands;
      },
      set(value) {
        this.setBrands(value);
      }
    }
  },
  watch: {},
  mounted() {
    this.getCatalog();
  },
  methods: {
    ...mapActions({
      setCategory: "setCategory",
      setBrands: "setBrands",
      setCategoryIdList: "setCategoryIdList",
      setClearFilter: "setClearFilter"
    }),
    getCatalog() {
      const vm = this;
      vm.loadingBeforeGetCatalog = true;
      vm.$axios
        .$get("/catalog/all-cats-brands")
        .then(res => {
          vm.categories = res.data.categories;
          vm.brands = res.data.brands;
        })
        .catch(e => {
          alert(e.message);
        })
        .finally(() => {
          vm.loadingBeforeGetCatalog = false;
        });
    },
    categoryExpand(value) {
      const vm = this;
      const alreadyValue = vm.categoryExpandList.findIndex(e => e === value);
      if (alreadyValue > -1) {
        vm.categoryExpandList.splice(alreadyValue, 1);
      } else {
        vm.categoryExpandList.push(value);
      }
    },
    selectCategoryAllFunc(value) {
      const vm = this;
      vm.selectCategoryAll = value;
    },
    activeClickAll(value) {
      const vm = this;
      let valueLength = 0;
      value.map(data => {
        if (vm.$store.getters.catalog.category.length > 0) {
          const checkData = vm.$store.getters.catalog.category.findIndex(
            e => e.id === data.id
          );
          if (checkData > -1) {
            valueLength += 1;
          }
        }
      });
      if (valueLength === value.length) {
        return true;
      } else {
        return false;
      }
    },
    clearFilter() {
      const vm = this;
      vm.setClearFilter();
    }
  }
};
</script>

<style lang="scss" scoped>
#filterCard {
  .filter-topic {
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding-bottom: 1.25rem;
    .filter-topic-font {
      font-size: 22px;
      color: #1b1b1c;
    }
    .clear-all {
      font-size: 15px;
      color: #1653ba;
      cursor: pointer;
    }
  }
  .custom-card {
    padding: 0 15px 0.625rem 15px;
    .category-group {
      padding-top: 0.625rem;
      border-bottom: 1px solid #d1d1d2;
      .expand-active {
        font-weight: bold;
      }
      .category-topic {
        display: flex;
        justify-content: space-between;
        align-items: center;
        margin: 20px 0;
        cursor: pointer;
      }
      .category-option-name {
        margin-bottom: 15px;
        cursor: pointer;
        color: rgba(0, 0, 0, 0.6);
        .sub-category {
          margin-left: 18px;
          .sub-category-all {
            margin: 10px 0;
          }
          .active-click-all {
            font-weight: bold;
          }
        }
      }
    }
    .brands-box-group {
      .brands-topic {
        display: flex;
        justify-content: space-between;
        align-items: center;
        margin: 15px 0;
        cursor: pointer;
      }
      .expand-active {
        font-weight: bold;
      }
    }
  }
}
</style>
<style lang="scss">
#categoryOption,
#brandsOption {
  .v-input--selection-controls {
    margin: 0;
    padding-top: 0;
  }
  .v-input__slot {
    margin-bottom: 0;
  }
}
</style>
